<table>
    <tr>
        <td class="preview-header">{{reportingDate | date:'shortDate'}}</td>
        <td class="preview-right-column">
            <button pButton icon="fa fa-plus" (click)="showAddReportDialog()"></button>
        </td>
    </tr>
    <ng-container *ngFor="let report of timeReports">
        <tr>
            <td class="preview-header">{{report.account.name}} - {{report.project.name}}</td>
            <td class="preview-header preview-right-column">{{report.internalHours}} / {{report.externalHours}}</td>
        </tr>
        <tr>
            <td>
                <div class="preview-description">{{report.workDescription}}</div>
            </td>
            <td class="prview-actions">
                <ng-template #editControls [ngTemplateOutlet]="editControls"
                  let-isTimeReportNotEditable="isTimeReportNotEditable"
                  [ngTemplateOutletContext]="{ isTimeReportNotEditable: !report.isEditable || !isUserAssignedToProject(report.project.id) }"
                >
                    <button pButton icon="fa fa-pencil" [disabled]="isTimeReportNotEditable" (click)="showEditReportDialog(report)" class="p-button-warning"></button>
                    <button pButton icon="fa fa-times" [disabled]="isTimeReportNotEditable" (click)="onDeleteTimeReport(report)" class="p-button-danger"></button>
                </ng-template>
            </td>
        </tr>
    </ng-container>
</table>

<p-dialog #editDialog *ngIf="isEditDialogVisible"
    [(visible)]="isEditDialogVisible"
    [responsive]="true"
    [resizable]="false"
    [focusOnShow]="false"
    showEffect="fade"
    appendTo="body"
    [modal]="true"
    [style]="{ 'width': '900px' }"
    [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }">
    <app-time-report
        [projects]="availableProjectsForReporting"
        [(selectedProject)]="selectedTimeReport.project"
        [(date)]="reportingDate"
        [(internalHours)]="selectedTimeReport.internalHours"
        [(externalHours)]="selectedTimeReport.externalHours"
        [(isOverhead)]="selectedTimeReport.isOverhead"
        [(description)]="selectedTimeReport.workDescription"
        [(startTime)]="startTime"
        submitButtonLabel="Save"
        [allowMultipleDates]="false"
        [isDisableDatePicker]="true"
        (submitButtonClick)="onEditTimeReport()"
        [appendInnerDialogToBody]="true"
    ></app-time-report>
</p-dialog>

<p-dialog #addDialog *ngIf="isAddDialogVisible"
    [(visible)]="isAddDialogVisible"
    appendTo="body"
    [responsive]="true"
    [resizable]="false"
    [focusOnShow]="false"
    showEffect="fade"
    [modal]="true"
    [style]="{ 'width': '900px'}"
    [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }">
    <app-time-report
        [projects]="availableProjectsForReporting"
        [autoResize]="false"
        [(selectedProject)]="selectedTimeReport.project"
        [(date)]="reportingDate"
        [(internalHours)]="selectedTimeReport.internalHours"
        [(externalHours)]="selectedTimeReport.externalHours"
        [(isOverhead)]="selectedTimeReport.isOverhead"
        [(description)]="selectedTimeReport.workDescription"
        [(startTime)]="startTime"
        submitButtonLabel="Add Report"
        [allowMultipleDates]="false"
        [isDisableDatePicker]="true"
        (selectedProjectChange)="ReloadDefaultHours($event)"
        (submitButtonClick)="onAddTimeReport()"
        [appendInnerDialogToBody]="true"
    ></app-time-report>
</p-dialog>
